#include <iostream>

using namespace std;







int main()
{
    int n,k;

    cin>>n>>k;

if(n<401)
        {
            int A[n];
        for(int i=0;i<n;i++)
        {
            cin>>A[i];

        }

        for(int l=0;l<k;l++)
        {
            int g=0;
            int s=0;
            int v=1;
            while(s<n)
            {v=1;
                if(A[s]>=0)
                    {
                        while(A[s+v]<0)
                       {

                        v++;}



                if(A[s+v]<A[s])
                {
                    A[s]=A[s]*-1-2;
                   g=1;
                   break;
                }
                s++;

                }else s++;


       }
        if(g==0)
            n=n-1;}
for(int i=0;i<n;i++)
        {



            if(A[i]>-1)
                cout<<A[i]<<" ";
        }
        }


        /*}else

        {
            int s1=0;
     int s0=0;
     int t;
     bool g=false;
     for(int i=0;i<n;i++)
     {
         if(s1<k)
         {
             cin>>t;
             if(t==1)
                s1++;
             if(t==0)
                s0++;
         }
         if(s1==k&&g==false)
         {
             for(int j=0;j<s0;j++)
                cout<<0<<" ";
                g=true;


         }
         if(g==true)
           {

           cin>>t;
         cout<<t<<" ";}


     }
     if(g==false)
        {for(int i=0;i<n-k;i++)
        cout<<0<<" ";
        }
        }




*/















    return 0;
        }